﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;


using System.Transactions;
using MySql.Data.MySqlClient;

namespace WindowsFormsApplication1
{
    /*
     
CREATE TABLE `t1` (
  `Key` int(10) unsigned NOT NULL auto_increment,
  `Val` varchar(100) NOT NULL,
  `Val2` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`Key`)
) ENGINE=InnoDB AUTO_INCREMENT=13 DEFAULT CHARSET=latin1;



CREATE TABLE `t2` (
  `Key` int(10) unsigned NOT NULL auto_increment,
  `Val` varchar(100) NOT NULL,
  PRIMARY KEY  (`Key`)
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=latin1;


     */
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            MessageBox.Show("Please manually lock the table (t2) to simulate external locking (Optimize Table) before clicking ok.  (lock tables t2 read)");

            DoTransactionScope();
        }

        private static string GetTestDBConn()
        {
            return "Use Affected Rows=true;allow user variables=yes;Server=localhost;Port=3308;Database=test;Uid=***;Pwd=***;Connect Timeout=35;default command timeout=90;charset=utf8";
        }

        private void DoTransactionScope()
        {
                        try
            {
                using (TransactionScope scope = new TransactionScope())
                {
                    DoInsertTable1();
                    DoInsertTable2();
                    scope.Complete();
                }
            }
            catch (Exception ee)
            {
                label1.Text =  ee.ToString();
            }
        }

        private static void DoInsertTable1()
        {           

            using (MySqlConnection conn = new MySqlConnection(GetTestDBConn()))
            using (MySqlCommand cmd = conn.CreateCommand())
            {
                conn.Open();                                
                cmd.CommandText = @"insert into t1 (Val,Val2) values (?value1, ?value2)"; ;
                cmd.CommandTimeout = 5;
                cmd.Parameters.AddWithValue("?value1", new Random().Next());
                cmd.Parameters.AddWithValue("?value2", new Random().Next());
                cmd.ExecuteNonQuery();
            }
        }

        private static void DoInsertTable2()
        {
            using (MySqlConnection conn = new MySqlConnection(GetTestDBConn()))
            using (MySqlCommand cmd = conn.CreateCommand())
            {
                conn.Open();
                cmd.CommandText = @"insert into t2 (Val) values (?value)";
                cmd.CommandTimeout = 5;
                cmd.Parameters.AddWithValue("?value", new Random().Next());
                cmd.ExecuteNonQuery();
            }
        }
    }
}
